#include <iostream>
#include<vector>
using namespace std;

long long g(long long n, long long k, vector<long long>& a) {
    long long s = 0;
    for (long long i = 1; i < n; i++) 
        s += a[i];
    long long e = a[0];
    long long ans = abs(s - e);
    for (long long i = 1; i < n - 1; i++) {
        s -= a[i];
        e += a[i];
        ans = max(ans, abs(s - e));
    }
    return ans;
}

long long t(long long n, long long k, vector<long long>& a) {
    long long s = 0;
    for (long long i = 0; i < n; i++)
        s += a[i];
    long long ans = max(abs(s - a[0] - a[1] - min(a[0], a[1])), abs(s - a[0] - a[n - 1] - min(a[0], a[n - 1])));
    ans = max(ans, abs(s - a[n - 1] - a[n - 2] - min(a[n - 1], a[n - 2])));
    long long l = a[0];
    long long r = s - a[0];
    for (long long i = 1; i < n - 1; i++) {
        r -= a[i];
        ans = max(ans, abs(max(r, l) - a[i]));
        l += a[i];
    }
    return ans;
}


int main() {
    ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
    long long n, k; cin >> n >> k;
    vector<long long> a(n);
    for (long long& i : a) cin >> i;
    if (k == 2) {
        cout << g(n, k, a);
    }
    else if (k == 3) {
        cout << t(n, k, a);
    }
}